// OLE_MFCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "at91boot_dll.h"
#include "OLE_MFC.h"
#include "OLE_MFCDlg.h"
#include "DlgProxy.h"

#include "FCError.h"

#define	DBGU_CIDR_MASK ~0x000F001F	// Remove version and SRAMSIZ (bug DBGU_CIDR S128 et S256 rev C)
#define PROG_FMR	0x00480100		// EFC FMR configuration for 48MHz 


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COLE_MFCDlg dialog

IMPLEMENT_DYNAMIC(COLE_MFCDlg, CDialog);

COLE_MFCDlg::COLE_MFCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COLE_MFCDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COLE_MFCDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pAutoProxy = NULL;

	// Create a new AT91BootDLL Object to manage COM Object
	m_pAT91BootDLL = new IAT91BootDLL;
	m_pAT91BootDLL->CreateDispatch(_T("AT91Boot_DLL.AT91BootDLL.1"));

}

COLE_MFCDlg::~COLE_MFCDlg()
{
	// If there is an automation proxy for this dialog, set
	//  its back pointer to this dialog to NULL, so it knows
	//  the dialog has been deleted.
	if (m_pAutoProxy != NULL)
		m_pAutoProxy->m_pDialog = NULL;

	delete m_pAT91BootDLL;
}

void COLE_MFCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COLE_MFCDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(COLE_MFCDlg, CDialog)
	//{{AFX_MSG_MAP(COLE_MFCDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_CLOSE()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COLE_MFCDlg message handlers

BOOL COLE_MFCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void COLE_MFCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void COLE_MFCDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR COLE_MFCDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Automation servers should not exit when a user closes the UI
//  if a controller still holds on to one of its objects.  These
//  message handlers make sure that if the proxy is still in use,
//  then the UI is hidden but the dialog remains around if it
//  is dismissed.

void COLE_MFCDlg::OnClose() 
{
	if (CanExit())
		CDialog::OnClose();
}

void COLE_MFCDlg::OnOK() 
{
	AT91BOOT_HANDLE_TYPE h_handle;
	CWnd* pWnd = GetDlgItem(IDC_EDIT_CHIP_ID);
	CHAR  pBuffer[20];
	char *pTest[10];
	long uValue, error_code;

	// MANDATORY: Allocate memory for each string in the table
	for (UINT i=0; i<10; i++)
		pTest[i] = (char *)malloc(100);

	// Scan all devices connected
	m_pAT91BootDLL->AT91Boot_Scan((char *)pTest);

	// Print all devices connected
	i= 0;
	while (pTest[i] != 0)
	{
		printf("Device %d = %s\n\r", i, pTest[i]);
		i++;
	}
	
	// Open first Device of the list
	m_pAT91BootDLL->AT91Boot_Open(pTest[0], &h_handle);

	if (h_handle != 0)
	{
		// Read DBGU Chip ID
		m_pAT91BootDLL->AT91Boot_Read_Int(h_handle, &uValue, 0xFFFFF240, &error_code);
		if (error_code != AT91C_BOOT_DLL_OK)
			sprintf(pBuffer, "Error 0x%X", error_code);
		else
			sprintf(pBuffer, "0x%08X", uValue);

		// Assume Target is a SAM7S256 (SAM7S-EK)
		// Otherwise, modify that part by yourself, it will be a good training! ;-)
		if ((uValue & DBGU_CIDR_MASK) == (0x270B0940 & DBGU_CIDR_MASK))
		{
			HRSRC hRsrc = FindResource(AfxGetResourceHandle(), MAKEINTRESOURCE(IDR_AT91SAM7S256_BASIC_MOUSE), "BASIC_MOUSE");
			HGLOBAL hglb = LoadResource(AfxGetResourceHandle(), hRsrc);
			CHAR *lpData = (CHAR *)LockResource(hglb);
			UINT BinarySize = (UINT)SizeofResource(AfxGetResourceHandle(), hRsrc);

			// MANDATORY: Program EFC_FMR register
			// Assume Target is at 48MHz
			m_pAT91BootDLL->AT91Boot_Write_Int(h_handle, PROG_FMR, 0xFFFFFF60, &error_code);
			if (error_code != AT91C_BOOT_DLL_OK){
				sprintf(pBuffer, "Error 0x%X", error_code);
				goto exit;
			}

			// Send File into SAM7S256 Flash
			m_pAT91BootDLL->AT91Boot_SAM7S256_Send_Flash(h_handle, 0, lpData, BinarySize, &error_code);
			if (error_code != AT91C_BOOT_DLL_OK){
				sprintf(pBuffer, "Error 0x%X", error_code);
				goto exit;
			}

exit:
			// Free Resource
			FreeResource(hglb);
		}

		// Display result
		pWnd->SetWindowText(_T(pBuffer));

		// Close Device
		m_pAT91BootDLL->AT91Boot_Close(h_handle);
	}

	// Free Allocated memory
	for (i=0; i<10; i++)
		free(pTest[i]);

//	if (CanExit())
//		CDialog::OnOK();
}

void COLE_MFCDlg::OnCancel() 
{
	if (CanExit())
		CDialog::OnCancel();
}

BOOL COLE_MFCDlg::CanExit()
{
	// If the proxy object is still around, then the automation
	//  controller is still holding on to this application.  Leave
	//  the dialog around, but hide its UI.
	if (m_pAutoProxy != NULL)
	{
		ShowWindow(SW_HIDE);
		return FALSE;
	}

	return TRUE;
}

