//*----------------------------------------------------------------------------
//*         ATMEL Microcontroller Software Support  -  ROUSSET  -
//*----------------------------------------------------------------------------
//* The software is delivered "AS IS" without warranty or condition of any
//* kind, either express, implied or statutory. This includes without
//* limitation any warranty or condition with respect to merchantability or
//* fitness for any particular purpose, or against the infringements of
//* intellectual property rights of others.
//*----------------------------------------------------------------------------
//* File Name           : main.h
//*----------------------------------------------------------------------------
#ifndef _MAIN_H
#define _MAIN_H

#ifdef AT91RM9200
#include "AT91RM9200.h"
#include "lib_AT91RM9200.h"
#define PAGE_BUF 0x2013F0
#endif

#ifdef AT91SAM9260
#include "AT91SAM9260.h"
#include "lib_AT91SAM9260.h"
#define PAGE_BUF 0x200013F0
#define AT91f_OpenSpiPIO() { \
	AT91C_BASE_PIOA->PIO_ASR = AT91C_PA1_SPI0_MOSI | AT91C_PA0_SPI0_MISO | AT91C_PA2_SPI0_SPCK | AT91C_PA3_SPI0_NPCS0; \
	AT91C_BASE_PIOA->PIO_PDR = AT91C_PA1_SPI0_MOSI | AT91C_PA0_SPI0_MISO | AT91C_PA2_SPI0_SPCK | AT91C_PA3_SPI0_NPCS0; \
	AT91C_BASE_PIOC->PIO_BSR = AT91C_PC11_SPI0_NPCS1; \
	AT91C_BASE_PIOC->PIO_PDR = AT91C_PC11_SPI0_NPCS1; \
}
#endif

#ifdef AT91SAM9261
#include "AT91SAM9261.h"
#include "lib_AT91SAM9261.h"
#define PAGE_BUF 0x3013F0
#define AT91f_OpenSpiPIO() { \
	AT91C_BASE_PIOA->PIO_ASR = AT91C_PA1_MOSI0 | AT91C_PA0_MISO0 | AT91C_PA2_SPCK0 | AT91C_PA3_NPCS00; \
	AT91C_BASE_PIOA->PIO_PDR = AT91C_PA1_MOSI0 | AT91C_PA0_MISO0 | AT91C_PA2_SPCK0 | AT91C_PA3_NPCS00; \
}
#endif

#ifdef AT91SAM9263
#include "AT91SAM9263.h"
#include "lib_AT91SAM9263.h"
#define PAGE_BUF 0x3013F0
#define AT91f_OpenSpiPIO() { \
        AT91C_BASE_PIOA->PIO_ASR = 0; \
        AT91C_BASE_PIOA->PIO_BSR = AT91C_PA5_SPI0_NPCS0 | AT91C_PA1_SPI0_MOSI | AT91C_PA0_SPI0_MISO | AT91C_PA2_SPI0_SPCK; \
        AT91C_BASE_PIOA->PIO_PDR = AT91C_PA5_SPI0_NPCS0 | AT91C_PA1_SPI0_MOSI | AT91C_PA0_SPI0_MISO | AT91C_PA2_SPI0_SPCK; \
}
#endif

#ifdef AT91SAM9XE128
#include "AT91SAM9XE128.h"
#include "lib_AT91SAM9XE128.h"
#define PAGE_BUF 0x3013F0
#define AT91f_OpenSpiPIO() { \
	AT91C_BASE_PIOA->PIO_ASR = AT91C_PA1_SPI0_MOSI | AT91C_PA0_SPI0_MISO | AT91C_PA2_SPI0_SPCK | AT91C_PA3_SPI0_NPCS0; \
	AT91C_BASE_PIOA->PIO_PDR = AT91C_PA1_SPI0_MOSI | AT91C_PA0_SPI0_MISO | AT91C_PA2_SPI0_SPCK | AT91C_PA3_SPI0_NPCS0; \
	AT91C_BASE_PIOC->PIO_BSR = AT91C_PC11_SPI0_NPCS1; \
	AT91C_BASE_PIOC->PIO_PDR = AT91C_PC11_SPI0_NPCS1; \
}
#endif

#ifdef AT91SAM9XE256
#include "AT91SAM9XE256.h"
#include "lib_AT91SAM9XE256.h"
#define PAGE_BUF 0x3013F0
#define AT91f_OpenSpiPIO() { \
	AT91C_BASE_PIOA->PIO_ASR = AT91C_PA1_SPI0_MOSI | AT91C_PA0_SPI0_MISO | AT91C_PA2_SPI0_SPCK | AT91C_PA3_SPI0_NPCS0; \
	AT91C_BASE_PIOA->PIO_PDR = AT91C_PA1_SPI0_MOSI | AT91C_PA0_SPI0_MISO | AT91C_PA2_SPI0_SPCK | AT91C_PA3_SPI0_NPCS0; \
	AT91C_BASE_PIOC->PIO_BSR = AT91C_PC11_SPI0_NPCS1; \
	AT91C_BASE_PIOC->PIO_PDR = AT91C_PC11_SPI0_NPCS1; \
}
#endif

#ifdef AT91SAM9XE512
#include "AT91SAM9XE512.h"
#include "lib_AT91SAM9XE512.h"
#define PAGE_BUF 0x3013F0
#define AT91f_OpenSpiPIO() { \
	AT91C_BASE_PIOA->PIO_ASR = AT91C_PA1_SPI0_MOSI | AT91C_PA0_SPI0_MISO | AT91C_PA2_SPI0_SPCK | AT91C_PA3_SPI0_NPCS0; \
	AT91C_BASE_PIOA->PIO_PDR = AT91C_PA1_SPI0_MOSI | AT91C_PA0_SPI0_MISO | AT91C_PA2_SPI0_SPCK | AT91C_PA3_SPI0_NPCS0; \
	AT91C_BASE_PIOC->PIO_BSR = AT91C_PC11_SPI0_NPCS1; \
	AT91C_BASE_PIOC->PIO_PDR = AT91C_PC11_SPI0_NPCS1; \
}
#endif

#ifdef AT91SAM9RL64
#include "AT91SAM9RL64.h"
#include "lib_AT91SAM9RL64.h"
#define PAGE_BUF 0x3013F0
#define AT91C_BASE_SPI0 AT91C_BASE_SPI
#define AT91C_ID_SPI0 AT91C_ID_SPI
#define AT91f_OpenSpiPIO() { \
	AT91C_BASE_PIOA->PIO_ASR = AT91C_PA26_MOSI | AT91C_PA25_MISO | AT91C_PA27_SPCK | AT91C_PA28_NPCS0; \
	AT91C_BASE_PIOA->PIO_PDR = AT91C_PA26_MOSI | AT91C_PA25_MISO | AT91C_PA27_SPCK | AT91C_PA28_NPCS0; \
}
#endif

#ifdef AT91CAP9
#include "AT91CAP9.h"
#include "lib_AT91CAP9.h"
#define PAGE_BUF 0x1013F0
#define AT91f_OpenSpiPIO() { \
	AT91C_BASE_PIOA->PIO_ASR = AT91C_PA28_SPI0_NPCS3A; \
	AT91C_BASE_PIOA->PIO_BSR = AT91C_PA0_SPI0_MISO | AT91C_PA1_SPI0_MOSI | AT91C_PA2_SPI0_SPCK | AT91C_PA3_SPI0_NPCS1 | AT91C_PA4_SPI0_NPCS2A | AT91C_PA5_SPI0_NPCS0; \
	AT91C_BASE_PIOA->PIO_PDR = AT91C_PA28_SPI0_NPCS3A | AT91C_PA1_SPI0_MOSI | AT91C_PA2_SPI0_SPCK | AT91C_PA3_SPI0_NPCS1 | AT91C_PA4_SPI0_NPCS2A | AT91C_PA5_SPI0_NPCS0; \
	AT91C_BASE_PIOD->PIO_BSR = AT91C_PD0_SPI0_NPCS2D | AT91C_PD1_SPI0_NPCS3D; \
	AT91C_BASE_PIOD->PIO_PDR = AT91C_PD0_SPI0_NPCS2D | AT91C_PD1_SPI0_NPCS3D; \
}
#endif

#ifdef AT91C340
#include "AT91C340.h"
#include "lib_AT91C340.h"
#define PAGE_BUF 0x3013F0
#endif

#ifdef AT91SAM7X128
#include "AT91SAM7X128.h"
#include "lib_AT91SAM7X128.h"
#define PAGE_BUF 0x202004
#endif

#ifdef AT91SAM7X256
#include "AT91SAM7X256.h"
#include "lib_AT91SAM7X256.h"
#define PAGE_BUF 0x202004
#endif

#ifdef AT91SAM7X512
#include "AT91SAM7X512.h"
#include "lib_AT91SAM7X512.h"
#define PAGE_BUF 0x202004
#endif

#ifdef AT91SAM7SE32
#include "AT91SAM7SE32.h"
#include "lib_AT91SAM7SE32.h"
#define PAGE_BUF 0x200013F0
#define AT91C_BASE_SPI0 AT91C_BASE_SPI
#endif

#ifdef AT91SAM7SE256
#include "AT91SAM7SE256.h"
#include "lib_AT91SAM7SE256.h"
#define PAGE_BUF 0x202004
#define AT91C_BASE_SPI0 AT91C_BASE_SPI
#endif

#ifdef AT91SAM7SE512
#include "AT91SAM7SE512.h"
#include "lib_AT91SAM7SE512.h"
#define PAGE_BUF 0x202004
#define AT91C_BASE_SPI0 AT91C_BASE_SPI
#endif

#ifdef AT91SAM7A3
#include "AT91SAM7A3.h"
#include "lib_AT91SAM7A3.h"
#define PAGE_BUF 0x202004
#endif

#endif
