//*----------------------------------------------------------------------------
//*         ATMEL Microcontroller Software Support  -  ROUSSET  -
//*----------------------------------------------------------------------------
//* The software is delivered "AS IS" without warranty or condition of any
//* kind, either express, implied or statutory. This includes without
//* limitation any warranty or condition with respect to merchantability or
//* fitness for any particular purpose, or against the infringements of
//* intellectual property rights of others.
//*----------------------------------------------------------------------------
//* File Name           : main.h
//* V1.81 02/Mar/06 JPP : Add AT91SAM9XE512
//*----------------------------------------------------------------------------

#ifdef AT91SAM7S32
#include "AT91SAM7S32.h"
#define AT91C_PAGE_SIZE	        128
// Define TCL_PAGE_BUF which is the address of the page content to write (written by the SAMBA TCL)
unsigned int *TCL_PAGE_BUF = (unsigned int *) (0x201400);
#endif

#ifdef AT91SAM7S321
#include "AT91SAM7S321.h"
#define AT91C_PAGE_SIZE	        128
// Define TCL_PAGE_BUF which is the address of the page content to write (written by the SAMBA TCL)
unsigned int *TCL_PAGE_BUF = (unsigned int *) (0x201400);
#endif

#ifdef AT91SAM7S64
#include "AT91SAM7S64.h"
#define AT91C_PAGE_SIZE	        128
// Define TCL_PAGE_BUF which is the address of the page content to write (written by the SAMBA TCL)
unsigned int *TCL_PAGE_BUF = (unsigned int *) (0x201400);
#endif

#ifdef AT91SAM7S128
#include "AT91SAM7S128.h"
#define AT91C_PAGE_SIZE	        256
// Define TCL_PAGE_BUF which is the address of the page content to write (written by the SAMBA TCL)
unsigned int *TCL_PAGE_BUF = (unsigned int *) (0x201400);
#endif

#ifdef AT91SAM7S256
#include "AT91SAM7S256.h"
#define AT91C_PAGE_SIZE	        256
// Define TCL_PAGE_BUF which is the address of the page content to write (written by the SAMBA TCL)
unsigned int *TCL_PAGE_BUF = (unsigned int *) (0x201400);
#endif

#ifdef AT91SAM7S512
#include "AT91SAM7S512.h"
#define AT91C_PAGE_SIZE	        256
#define AT91C_BANK_SIZE         256*1024
#define AT91C_EFC0		0
#define AT91C_EFC1		1
// Define TCL_PAGE_BUF which is the address of the page content to write (written by the SAMBA TCL)
unsigned int *TCL_PAGE_BUF = (unsigned int *) (0x201400);
#endif

#ifdef AT91SAM7A3
#include "AT91SAM7A3.h"
#define AT91C_PAGE_SIZE	        256
// Define TCL_PAGE_BUF which is the address of the page content to write (written by the SAMBA TCL)
unsigned int *TCL_PAGE_BUF = (unsigned int *) (0x201400);
#endif

#ifdef AT91SAM7X128
#include "AT91SAM7X128.h"
#define AT91C_PAGE_SIZE	        256
// Define TCL_PAGE_BUF which is the address of the page content to write (written by the SAMBA TCL)
unsigned int *TCL_PAGE_BUF = (unsigned int *) (0x201400);
#endif

#ifdef AT91SAM7X256
#include "AT91SAM7X256.h"
#define AT91C_PAGE_SIZE	        256
// Define TCL_PAGE_BUF which is the address of the page content to write (written by the SAMBA TCL)
unsigned int *TCL_PAGE_BUF = (unsigned int *) (0x201400);
#endif

#ifdef AT91SAM7X512
#include "AT91SAM7X512.h"
#define AT91C_PAGE_SIZE	        256
#define AT91C_BANK_SIZE         256*1024
#define AT91C_EFC0		0
#define AT91C_EFC1		1
// Define TCL_PAGE_BUF which is the address of the page content to write (written by the SAMBA TCL)
unsigned int *TCL_PAGE_BUF = (unsigned int *) (0x201400);
#endif

#ifdef AT91SAM7XC128
#include "AT91SAM7XC128.h"
#define AT91C_PAGE_SIZE	        256
// Define TCL_PAGE_BUF which is the address of the page content to write (written by the SAMBA TCL)
unsigned int *TCL_PAGE_BUF = (unsigned int *) (0x201400);
#endif

#ifdef AT91SAM7XC256
#include "AT91SAM7XC256.h"
#define AT91C_PAGE_SIZE	        256
// Define TCL_PAGE_BUF which is the address of the page content to write (written by the SAMBA TCL)
unsigned int *TCL_PAGE_BUF = (unsigned int *) (0x201400);
#endif

#ifdef AT91SAM7XC512
#include "AT91SAM7XC512.h"
#define AT91C_PAGE_SIZE	        256
#define AT91C_BANK_SIZE         256*1024
#define AT91C_EFC0		0
#define AT91C_EFC1		1
// Define TCL_PAGE_BUF which is the address of the page content to write (written by the SAMBA TCL)
unsigned int *TCL_PAGE_BUF = (unsigned int *) (0x201400);
#endif

#ifdef AT91SAM7SE32
#include "AT91SAM7SE32.h"
#define AT91C_PAGE_SIZE	        128
// Define TCL_PAGE_BUF which is the address of the page content to write (written by the SAMBA TCL)
unsigned int *TCL_PAGE_BUF = (unsigned int *) (0x201400);
#endif

#ifdef AT91SAM7SE256
#include "AT91SAM7SE256.h"
#define AT91C_PAGE_SIZE		256
#define AT91C_BANK_SIZE         256*1024
#define AT91C_EFC0		0
#define AT91C_EFC1		1
#define AT91C_BASE_EFC0         AT91C_BASE_EFC
#define AT91C_BASE_EFC1         AT91C_BASE_EFC
// Define TCL_PAGE_BUF which is the address of the page content to write (written by the SAMBA TCL)
unsigned int *TCL_PAGE_BUF = (unsigned int *) (0x201400);
#endif

#ifdef AT91SAM7SE512
#include "AT91SAM7SE512.h"
#define AT91C_PAGE_SIZE		256
#define AT91C_BANK_SIZE         256*1024
#define AT91C_EFC0		0
#define AT91C_EFC1		1
// Define TCL_PAGE_BUF which is the address of the page content to write (written by the SAMBA TCL)
unsigned int *TCL_PAGE_BUF = (unsigned int *) (0x201400);
#endif

#ifdef AT91SAM9XE128
#include "AT91SAM9XE128.h"
#define AT91C_PAGE_SIZE	        512
// Define TCL_PAGE_BUF which is the address of the page content to write (written by the SAMBA TCL)
unsigned int *TCL_PAGE_BUF = (unsigned int *) (0x00301400);
#endif

#ifdef AT91SAM9XE256
#include "AT91SAM9XE256.h"
#define AT91C_PAGE_SIZE	        512
// Define TCL_PAGE_BUF which is the address of the page content to write (written by the SAMBA TCL)
unsigned int *TCL_PAGE_BUF = (unsigned int *) (0x00301400);
#endif

#ifdef AT91SAM9XE512
#include "AT91SAM9XE512.h"
#define AT91C_PAGE_SIZE	        512
// Define TCL_PAGE_BUF which is the address of the page content to write (written by the SAMBA TCL)
unsigned int *TCL_PAGE_BUF = (unsigned int *) (0x00301400);
#endif
